'use strict';

Object.defineProperty(exports, '__esModule', {
  value: true
});

var _createClass = (function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ('value' in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; })();

var _get = function get(_x, _x2, _x3) { var _again = true; _function: while (_again) { var object = _x, property = _x2, receiver = _x3; desc = parent = getter = undefined; _again = false; if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { _x = parent; _x2 = property; _x3 = receiver; _again = true; continue _function; } } else if ('value' in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } } };

exports.animationFrame = animationFrame;

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError('Cannot call a class as a function'); } }

function _inherits(subClass, superClass) { if (typeof superClass !== 'function' && superClass !== null) { throw new TypeError('Super expression must either be null or a function, not ' + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var raf = requestAnimationFrame;
var cancelRaf = cancelAnimationFrame;

// Simple ticking decorator that manages destroying
// requestAnimationFrame when component unmounts.
// All you have to supply is the `callback` function
// which gets called every tick.

function animationFrame(callback) {

  return function (DecoratedComponent) {
    return (function (_Component) {
      _inherits(AnimationFrame, _Component);

      function AnimationFrame() {
        _classCallCheck(this, AnimationFrame);

        _get(Object.getPrototypeOf(AnimationFrame.prototype), 'constructor', this).apply(this, arguments);
      }

      _createClass(AnimationFrame, [{
        key: 'componentWillMount',
        value: function componentWillMount() {
          var _this = this;

          this.tick = function () {
            callback(_this.props);
            raf(_this.tick);
          };
        }
      }, {
        key: 'componentDidMount',
        value: function componentDidMount() {
          this.rafId = raf(this.tick);
        }
      }, {
        key: 'componentWillUnmount',
        value: function componentWillUnmount() {
          cancelRaf(this.rafId);
        }
      }, {
        key: 'render',
        value: function render() {
          return _react2['default'].createElement(DecoratedComponent, this.props);
        }
      }]);

      return AnimationFrame;
    })(_react.Component);
  };
}

// Simple ticking component, just supply `onTick` prop

var AnimationFrame = (function (_Component2) {
  _inherits(AnimationFrame, _Component2);

  function AnimationFrame() {
    _classCallCheck(this, AnimationFrame);

    _get(Object.getPrototypeOf(AnimationFrame.prototype), 'constructor', this).apply(this, arguments);
  }

  _createClass(AnimationFrame, [{
    key: 'componentWillMount',
    value: function componentWillMount() {
      var _this2 = this;

      this.tick = function () {
        _this2.props.onTick();
        raf(_this2.tick);
      };
    }
  }, {
    key: 'componentDidMount',
    value: function componentDidMount() {
      this.rafId = raf(this.tick);
    }
  }, {
    key: 'componentWillUnmount',
    value: function componentWillUnmount() {
      cancelRaf(this.rafId);
    }
  }, {
    key: 'render',
    value: function render() {
      return this.props.children;
    }
  }], [{
    key: 'propTypes',
    value: {
      onTick: _react.PropTypes.func.isRequired
    },
    enumerable: true
  }, {
    key: 'defaultProps',
    value: {
      children: null
    },
    enumerable: true
  }]);

  return AnimationFrame;
})(_react.Component);

exports.AnimationFrame = AnimationFrame;